diff --git a/minecraft/forge/.env.example b/minecraft/forge/.env.example
index 3fdd8b5..2669eef 100644
--- a/minecraft/forge/.env.example
+++ b/minecraft/forge/.env.example
@@ -1,30 +1,15 @@
-# Copyright (C) 2020 Jef Roosens
-
-# This program is free software: you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation, either version 3 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program. If not, see .
-
-
# Build arguments
MC_VERSION=
FORGE_VERSION=
# Environment variables
-XMS=4
+# If XMS is left blank, it uses the same value as XMX
+XMS=
XMX=4
# Mount points
+# The mods should be placed inside the CONFIG_DIR under `mods`
CONFIG_DIR=
-MODS_DIR=
WORLDS_DIR=
# Other
diff --git a/minecraft/forge/Dockerfile b/minecraft/forge/Dockerfile
index c398484..796426b 100644
--- a/minecraft/forge/Dockerfile
+++ b/minecraft/forge/Dockerfile
@@ -1,27 +1,18 @@
-# Copyright (C) 2020 Jef Roosens
-
-# This program is free software: you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation, either version 3 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program. If not, see .
-
-
-FROM openjdk:8-slim
+FROM openjdk:8-jre-slim
# Build arguments
ARG MC_VERSION
ARG FORGE_VERSION
+# Install mcstatus for healthchecks
+RUN apt update && \
+ apt install --no-install-recommends -y python3-minimal python3-setuptools python3-pip && \
+ python3 -m pip install mcstatus && \
+ apt --purge remove -y python3-pip python3-setuptools && \
+ apt clean
+
# Create worlds and config directory
-WORKDIR /mc
+WORKDIR /app
RUN mkdir worlds config
# Download installer jar
@@ -29,10 +20,7 @@ ADD "https://files.minecraftforge.net/maven/net/minecraftforge/forge/${MC_VERSIO
# Install forge & remove installer
RUN java -jar installer.jar server --installServer && \
-rm installer.jar installer.jar.log
-
-# Forge doesn't use one single name, so this is needed to know the name of the executable
-ENV FORGE_JAR="forge-${MC_VERSION}-${FORGE_VERSION}.jar"
+ rm installer.jar installer.jar.log
# Store the cache in an anonymous volume, which means it won't get stored in the other volumes
VOLUME /mc/config/cache
@@ -40,34 +28,16 @@ VOLUME /mc/config/cache
WORKDIR /mc/config
# Default value to keep users from eating up all ram accidentally
-ENV XMS=4
+ENV XMX=4
+ENV MC_VERSION="${MC_VERSION}"
+ENV FORGE_VERSION="${FORGE_VERSION}"
+# Forge doesn't use one single name, so this is needed to know the name of the executable
+ENV FORGE_JAR="forge-${MC_VERSION}-${FORGE_VERSION}.jar"
-# We copy over the server jar(s) as well to make the backup more reproducible to deploy
-ENTRYPOINT mv -n /mc/*.jar /mc/*.json /mc/libraries /mc/config && \
-echo "eula=true" > /mc/config/eula.txt && \
-java \
--Xms"${XMS}G" \
--Xmx"${XMX:-$XMS}G" \
--XX:+UseG1GC \
--XX:+ParallelRefProcEnabled \
--XX:MaxGCPauseMillis=200 \
--XX:+UnlockExperimentalVMOptions \
--XX:+DisableExplicitGC \
--XX:+AlwaysPreTouch \
--XX:G1NewSizePercent="$([ $XMS -gt 12 ] && echo 40 || echo 30)" \
--XX:G1MaxNewSizePercent="$([ $XMS -gt 12 ] && echo 50 || echo 40)" \
--XX:G1HeapRegionSize="$([ $XMS -gt 12 ] && echo 16 || echo 8)"M \
--XX:G1ReservePercent="$([ $XMS -gt 12 ] && echo 15 || echo 20)" \
--XX:G1HeapWastePercent=5 \
--XX:G1MixedGCCountTarget=4 \
--XX:InitiatingHeapOccupancyPercent="$([ $XMS -gt 12 ] && echo 20 || echo 15)" \
--XX:G1MixedGCLiveThresholdPercent=90 \
--XX:G1RSetUpdatingPauseTimePercent=5 \
--XX:SurvivorRatio=32 \
--XX:+PerfDisableSharedMem \
--XX:MaxTenuringThreshold=1 \
--Dusing.aikars.flags=https://mcflags.emc.gs \
--Daikars.new.flags=true \
--jar "$FORGE_JAR" \
---universe /mc/worlds \
---nogui
+# Entrypoint runs in /app/config
+COPY entrypoint.sh /entrypoint.sh
+WORKDIR /app/config
+ENTRYPOINT /entrypoint.sh
+
+HEALTHCHECK --interval=30s --timeout=5s --start-period=15s --retries=3 \
+ CMD mcstatus localhost:25565 ping
diff --git a/minecraft/forge/docker-compose.yml b/minecraft/forge/docker-compose.yml
index e2a78b5..5bd5cdf 100644
--- a/minecraft/forge/docker-compose.yml
+++ b/minecraft/forge/docker-compose.yml
@@ -1,30 +1,14 @@
-# Copyright (C) 2020 Jef Roosens
-
-# This program is free software: you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation, either version 3 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program. If not, see .
-
-
version: '3.5'
services:
- forge:
+ app:
build:
context: .
args:
- - 'MC_VERSION=${MC_VERSION}'
- - 'FORGE_VERSION=${FORGE_VERSION}'
- image: 'mc-forge-server:${MC_VERSION}-${FORGE_VERSION}'
+ - 'MC_VERSION'
+ - 'FORGE_VERSION'
+ image: 'chewingbever/mc-forge:${MC_VERSION}-${FORGE_VERSION}'
- restart: 'unless-stopped'
+ restart: 'always'
stdin_open: true
tty: true
@@ -34,6 +18,10 @@ services:
ports:
- '$PORT:25565'
volumes:
- - '$CONFIG_DIR:/mc/config'
- - '$MODS_DIR:/mc/config/mods'
- - '$WORLDS_DIR:/mc/worlds'
+ - '$CONFIG_DIR:/app/config'
+ - '$WORLDS_DIR:/app/worlds'
+
+# These volumes only get created if you use them in the env file
+volumes:
+ config:
+ worlds:
diff --git a/minecraft/forge/entrypoint.sh b/minecraft/forge/entrypoint.sh
new file mode 100755
index 0000000..3765418
--- /dev/null
+++ b/minecraft/forge/entrypoint.sh
@@ -0,0 +1,37 @@
+#!/usr/bin/env bash
+
+# Accept the EULA
+echo "eula=true" > /app/config/eula.txt
+
+# Log the last-used version, so we know which version to use when running it again (e.g. loading the backup)
+echo "${MC_VERSION}, Forge v${FORGE_VERSION}" >> /app/config/versions.txt
+
+XMS="${XMS:-$XMX}"
+
+# Launch the actual server
+exec java \
+ -Xms"${XMS}G" \
+ -Xmx"${XMX:-$XMS}G" \
+ -XX:+UseG1GC \
+ -XX:+ParallelRefProcEnabled \
+ -XX:MaxGCPauseMillis=200 \
+ -XX:+UnlockExperimentalVMOptions \
+ -XX:+DisableExplicitGC \
+ -XX:+AlwaysPreTouch \
+ -XX:G1NewSizePercent="$([ $XMS -gt 12 ] && echo 40 || echo 30)" \
+ -XX:G1MaxNewSizePercent="$([ $XMS -gt 12 ] && echo 50 || echo 40)" \
+ -XX:G1HeapRegionSize="$([ $XMS -gt 12 ] && echo 16 || echo 8)"M \
+ -XX:G1ReservePercent="$([ $XMS -gt 12 ] && echo 15 || echo 20)" \
+ -XX:G1HeapWastePercent=5 \
+ -XX:G1MixedGCCountTarget=4 \
+ -XX:InitiatingHeapOccupancyPercent="$([ $XMS -gt 12 ] && echo 20 || echo 15)" \
+ -XX:G1MixedGCLiveThresholdPercent=90 \
+ -XX:G1RSetUpdatingPauseTimePercent=5 \
+ -XX:SurvivorRatio=32 \
+ -XX:+PerfDisableSharedMem \
+ -XX:MaxTenuringThreshold=1 \
+ -Dusing.aikars.flags=https://mcflags.emc.gs \
+ -Daikars.new.flags=true \
+ -jar /app/"$FORGE_JAR" \
+ --universe /app/worlds \
+ --nogui
diff --git a/minecraft/papermc/Dockerfile b/minecraft/papermc/Dockerfile
index 24bf0de..291e717 100644
--- a/minecraft/papermc/Dockerfile
+++ b/minecraft/papermc/Dockerfile
@@ -23,7 +23,9 @@ VOLUME /app/config/cache
# Default value to keep users from eating up all ram accidentally
-ENV XMS=4
+ENV XMX=4
+ENV MC_VERSION="${MC_VERSION}"
+ENV PAPERMC_VERSION="${PAPERMC_VERSION}"
# Document exposed ports
EXPOSE 25565
diff --git a/minecraft/papermc/docker-compose.yml b/minecraft/papermc/docker-compose.yml
index bf70e07..4e77ba5 100644
--- a/minecraft/papermc/docker-compose.yml
+++ b/minecraft/papermc/docker-compose.yml
@@ -1,19 +1,3 @@
-# Copyright (C) 2020 Jef Roosens
-
-# This program is free software: you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation, either version 3 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program. If not, see .
-
-
version: '3.5'
services:
app:
@@ -22,7 +6,7 @@ services:
args:
- 'MC_VERSION'
- 'PAPERMC_VERSION'
- image: 'chewingbever/mc-papermc-server:${MC_VERSION}-${PAPERMC_VERSION}'
+ image: 'chewingbever/mc-papermc:${MC_VERSION}-${PAPERMC_VERSION}'
restart: 'always'
# Needed to interact with server console
diff --git a/minecraft/papermc/entrypoint.sh b/minecraft/papermc/entrypoint.sh
new file mode 100755
index 0000000..1876d54
--- /dev/null
+++ b/minecraft/papermc/entrypoint.sh
@@ -0,0 +1,37 @@
+#!/usr/bin/env bash
+
+# Accept the EULA
+echo "eula=true" > /app/config/eula.txt
+
+# Log the last-used version, so we know which version to use when running it again (e.g. loading the backup)
+echo "${MC_VERSION}, PaperMC v${PAPERMC_VERSION}" >> /app/config/versions.txt
+
+XMS="${XMS:-$XMX}"
+
+# Launch the actual server
+java \
+ -Xms"${XMS}G" \
+ -Xmx"${XMX:-$XMS}G" \
+ -XX:+UseG1GC \
+ -XX:+ParallelRefProcEnabled \
+ -XX:MaxGCPauseMillis=200 \
+ -XX:+UnlockExperimentalVMOptions \
+ -XX:+DisableExplicitGC \
+ -XX:+AlwaysPreTouch \
+ -XX:G1NewSizePercent="$([ $XMS -gt 12 ] && echo 40 || echo 30)" \
+ -XX:G1MaxNewSizePercent="$([ $XMS -gt 12 ] && echo 50 || echo 40)" \
+ -XX:G1HeapRegionSize="$([ $XMS -gt 12 ] && echo 16 || echo 8)"M \
+ -XX:G1ReservePercent="$([ $XMS -gt 12 ] && echo 15 || echo 20)" \
+ -XX:G1HeapWastePercent=5 \
+ -XX:G1MixedGCCountTarget=4 \
+ -XX:InitiatingHeapOccupancyPercent="$([ $XMS -gt 12 ] && echo 20 || echo 15)" \
+ -XX:G1MixedGCLiveThresholdPercent=90 \
+ -XX:G1RSetUpdatingPauseTimePercent=5 \
+ -XX:SurvivorRatio=32 \
+ -XX:+PerfDisableSharedMem \
+ -XX:MaxTenuringThreshold=1 \
+ -Dusing.aikars.flags=https://mcflags.emc.gs \
+ -Daikars.new.flags=true \
+ -jar /app/server.jar \
+ --universe /app/worlds \
+ --nogui